#ifndef LANCHAT_LINUX_H
#define LANCHAT_LINUX_H

#include <ncurses.h>

/*USER CUSTOMIZATION AREA*/

// define below your operating system (max. 20 chars)
#define OS "Linux"

//your color (RGB values)
#define COLOR_R 100 
#define COLOR_G 50 
#define COLOR_B 200

/*END OF USER CUSTOMIZATION AREA*/

// current linux lanchat version
#define VER "1.0.2"

// internal boradcast IP address
#define LC_BROADCAST 255

#define BUF		4096
#define LAG		100
#define AUTOALIVE	5000

// linux lanchat internal messages
#define LC_LINUX_NULL		0
#define LC_LINUX_MSG		1
#define LC_LINUX_STATUS		2
#define LC_LINUX_POP		3
#define LC_LINUX_HELP		4
#define LC_LINUX_CREDITS	5
#define LC_LINUX_UNKCMD		6
#define LC_LINUX_WHOIS		7
#define LC_LINUX_NICKLN		8
#define LC_LINUX_REQUEST	9
#define LC_LINUX_CLEAR		10

// lanchat messages
#define LC_NEWTOPIC 50
#define LC_TOPIC 53
#define LC_TOPIC_TIME 54
#define LC_CANTPOP 55
#define LC_POPOK 57
#define LC_POPUP 62
#define LC_MOTHER 78
#define LC_NORMAL 100
#define LC_AWAY 101
#define LC_ALIVE 102
#define LC_AWAY_ALIVE 115
#define LC_NEWNICK 116
#define LC_ME 104
#define LC_JOIN 107
#define LC_LEAVE 108
#define LC_REQ_AWAY 110
#define LC_REQ_ALIVE 111
#define LC_START_AWAY 113
#define LC_END_AWAY 114
#define LC_REQ_STATUS_EX 90
#define LC_STATUS_EX 91
#define LC_SLC_OK 92
#define LC_ADD_TO_ROOM 96
#define LC_REMOVE_FROM_ROOM 98

// port
#define INPORT 16128

// crypt method
#define CRYPT_DEFAULT 14

struct USER {
    char nick[20];
    unsigned char away;
    unsigned char room;    
    unsigned char lag;    

};

struct USER users[255];

struct LCHEAD {
        char cHead[4];
        unsigned char type;
        unsigned int sender;
        unsigned int dest;
        char nick[20];
        unsigned char nR;
        unsigned char nG;
        unsigned char nB;
        unsigned char xVal;
        unsigned char cCrypt;   
        unsigned char Female;
	unsigned long Reserved1;
        unsigned long Reserved2;
        unsigned long Reserved3;
        char data[4096];
} hsnd,hrcv;


/************** function prototypes & macros ***************/

#define cmp(x,y) strncasecmp(x,y,strlen(y))

#define snd() send=sendto(ssock,&hsnd,sizeof(hsnd)-4089+strlen(hsnd.data),\
0,(struct sockaddr *)&toaddr,sizeof(toaddr));

extern void usage(void);
extern void cleanup(void);
extern void updatewin(WINDOW *);
extern void updateall(void);
extern char *atime(int);
extern char *adate(void);
extern int auser(char *);
extern void use_exit(int);
extern int checkstr(char *, char *);
extern int checkstr(char *, char *);
extern void crypt(char *, int, int);
extern void decrypt(int, char *, int, int);
extern void make_userlist(void);
extern void decr(void);
extern void sline(void);
extern void flog(char*);
extern void logtime(void);
extern void show_normal(void);
extern void show_status(void);
extern void show_me(void);
extern void show_away(void);
extern void show_pop(void);
extern void show_msg(void);
extern void show_join(void);
extern void change_topic(void);
extern void show_leave(void);
extern void show_stats(void);
extern void show_help(void);
extern void show_credits(void);
extern void show_resurrected(void);
extern void show_unknown(void);
extern void show_went_away(void);
extern void show_back_away(void);
extern int prepare_message(void);


/******* global variables in lc_main.c *********/

extern WINDOW *inputwin, *defwin, *headwin, *split1win, *split2win, *split3win, *userwin;
extern char host[ 30 ], logname[ 20 ], myip[ 16 ], since[ 9 ], away[ 250 ],
     topic[ 75 ], topictime[ 9 ], readbuffer[ 4096 ];
extern unsigned int  send_size, pop_mode;
extern unsigned long bytes_rcv, total_msg;
extern FILE* f;

#endif /* LANCHAT_LINUX_H */
