/*
 
  LANChat Linux version 1.0.1 fully compatible with windows LC40
  Based on LC 4.0 specification by Piotr Kowalski <goro@vc.pl> 
  
  (c) Mateusz Skoczewski <melun@friko2.onet.pl>
 
  ----------------------------------------------------------------------
  The Linux LANChat and related utilities are free software; you can
  redistribute it and/or modify it under the terms of the GNU Library
  general Public License as published by the Free Software Foundation;
  either version 2 of the License, or (at your option) any later version.
 
*/

#include "lanchat.h"
#include <curses.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#define cmp(x,y) strncasecmp(x,y,strlen(y))

#define snd() send=sendto(ssock,&hsnd,sizeof(hsnd)-4089+strlen(hsnd.data),\
0,(struct sockaddr *)&toaddr,sizeof(toaddr));

WINDOW *inputwin, *defwin, *headwin, *split1win, *split2win, *userwin;

char host[ 30 ], logname[ 15 ], myip[ 16 ], since[ 9 ], away[ 250 ], topic[ 75 ], topictime[ 9 ],
readbuffer[ 4096 ];

unsigned int send_size;
unsigned long bytes_rcv=0,
	      total_msg=0;
unsigned int  pop_mode;

FILE* f;


void updateall()
{
    wnoutrefresh( headwin );
    wnoutrefresh( defwin );
    wnoutrefresh( userwin );
    wnoutrefresh( inputwin );
    wnoutrefresh( split1win );
    wnoutrefresh( split2win );
    doupdate();
}

char *atime( int o )
{
    static char tt[ 9 ];
    static time_t now;
    static struct tm *tm;
    time( &now );
    tm = localtime( &now );
    strftime( tt, 9, "%H:%M:%S", tm );
    return tt;
}

char *adate()
{
    static char tt[ 12 ];
    static time_t now;
    static struct tm *tm;
    time( &now );
    tm = localtime( &now );
    strftime( tt, 12, "%d-%b-%Y", tm );
    return tt;
}

int auser( char *fuser )
{
    int num;
    for ( num = 0; num < 255; num++ ) 
 if ( strcasecmp( users[ num ].nick, fuser ) == 0 ) return( num );
    return - 1;
}

void use_exit( sig ) int sig;
{
    signal( SIGINT, use_exit );
}


int checkstr( char *ndata, char *nfuser )
{
    int i;
    char data[ 4096 ], fuser[ 20 ];
    strcpy( data, ndata );
    strcpy( fuser, nfuser );
    for ( i = 0; i <= strlen( data ); i++ ) data[ i ] = tolower( data[ i ] );
    for ( i = 0; i <= strlen( fuser ); i++ ) fuser[ i ] = tolower( fuser[ i ] );
    if ( strstr( data, fuser ) == 0 ) return 0;
    else return - 1;
}

void crypt( char *data, int cSender, int cDest ) 
{

 unsigned int qe, qq;

int x;
hsnd.xVal = rand() % 8 + 9;

x = hsnd.xVal;
qq = strlen( data );
send_size = qq + 4;
for ( qe = 0; qe < qq; qe++ ) 
    if ( data[ qe ] != 0 ) 
        {
         data[ qe ] = ( char ) data[ qe ] + ( 20-x );
         
         data[ qe ] = 255-data[ qe ];
         
         data[ qe ] = ( char ) ( data[ qe ] + cSender + cDest );
         
        }
        data[ qe + 1 ] = 'L';
data[ qe + 2 ] = 'C';
data[ qe + 3 ] = '4';
data[ qe + 4 ] = '0';

}

void decrypt( int x, char *data, int cSender, int cDest ) 
{
 unsigned int qe, qq;

qq = strlen( data );
for ( qe = 0; qe < qq; qe++ ) 
    if ( data[ qe ] != 0 ) 
        {
         data[ qe ] = ( char ) ( data[ qe ] - cSender - cDest );
         
         data[ qe ] = 255-data[ qe ];
         
         data[ qe ] = ( char ) ( data[ qe ] - 20 + x );
         
        }
        }

        void make_userlist( void )
    {
        unsigned int i, j = 2;
        werase( userwin );
        wattrset( userwin, COLOR_PAIR( 5 ) | A_BOLD );
        waddstr( userwin, " ONLINE  LIST:\n\n" );
        for ( i = 0; i < 255; i++ ) 
            {
                if ( strlen( users[ i ].nick ) > 0 )
            {
                if ( users[ i ].away != 1 ) wattrset( userwin, COLOR_PAIR( 4 ) | A_BOLD );
                    else wattrset( userwin, COLOR_PAIR( 4 ) );
                    mvwaddstr( userwin, j, 0, users[ i ].nick );
                    wattrset( userwin, COLOR_PAIR( 4 ) );
                    if ( users[ i ].away == 1 ) {
                        mvwaddstr( userwin, j, 12, " (A)" );
                    }
                    j++;
                }
        }
        wrefresh( userwin );
        wrefresh( inputwin );
    }


void decr( void )
{
    decrypt( hrcv.xVal, hrcv.data, hrcv.sender, hrcv.dest );
    hrcv.data[ strlen( hrcv.data ) - 2 ] = '\0';
}

void sline( void )
{
    wprintw( defwin, "%s\n", hrcv.data );
    wrefresh( defwin );
    wrefresh( inputwin );
}

void flog( char* a )
{
    chdir( "./logs" );
    f = fopen( adate(), "a" );
    fwrite( a, strlen( a ), 1, f );
    fclose( f );
    fflush( NULL );
}

void show_normal( void )
{
    int ncolor;
    if ( hrcv.sender == hsnd.sender ) ncolor = 3;
    else ncolor = 4;

    decr();

    wattrset( defwin, COLOR_PAIR( ncolor ) | A_BOLD );
    wprintw( defwin, "<" );

    if ( checkstr( hrcv.data, users[ hsnd.sender ].nick ) == 0 )
        wattrset( defwin, COLOR_PAIR( 5 ) );
    else
        wattrset( defwin, COLOR_PAIR( 8 ) | A_BOLD );

    wprintw( defwin, "%s", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( ncolor ) | A_BOLD );
    wprintw( defwin, ">   " );
    wattrset( defwin, COLOR_PAIR( 5 ) );
    sline();

    flog( "<" );
    flog( hrcv.nick );
    flog( ">   " );
    flog( hrcv.data );
    flog( "\n" );
}

void show_status( void )
{
    unsigned int i = 0;
    decr();

    waddstr( defwin, "* " );
    wattrset( defwin, A_BOLD );
    waddstr( defwin, "Nick: " );
    wattrset( defwin, A_NORMAL );
    while ( hrcv.data[ i ] != '\x07' ) {
        waddch( defwin, hrcv.data[ i ] );
        i++;
    }
    i++;
    wattrset( defwin, A_BOLD );
    waddstr( defwin, " Address: " );
    wattrset( defwin, A_NORMAL );
    while ( hrcv.data[ i ] != '\x07' ) {
        waddch( defwin, hrcv.data[ i ] );
        i++;
    }
    i++;
    wattrset( defwin, A_BOLD );
    waddstr( defwin, " IP=" );
    wattrset( defwin, A_NORMAL );
    while ( hrcv.data[ i ] != '\x07' ) {
        waddch( defwin, hrcv.data[ i ] );
        i++;
    }
    i++;
    waddch( defwin, '\n' );
    wattrset( defwin, A_BOLD );
    waddstr( defwin, "Using: " );
    wattrset( defwin, A_NORMAL );
    while ( hrcv.data[ i ] != '\x07' ) {
        waddch( defwin, hrcv.data[ i ] );
        i++;
    }
    i++;
    wattrset( defwin, A_BOLD );
    waddstr( defwin, " Under: " );
    wattrset( defwin, A_NORMAL );
    while ( hrcv.data[ i ] != '\x07' ) {
        waddch( defwin, hrcv.data[ i ] );
        i++;
    }
    i++;

    wattrset( defwin, A_BOLD );
    waddstr( defwin, " User is: " );
    wattrset( defwin, A_NORMAL );
    if ( hrcv.data[ i ] == '0' ) waddstr( defwin, "alive" );
    else waddstr( defwin, "away" );
    i = i + 2;
    wattrset( defwin, A_BOLD );
    waddstr( defwin, " Online since: " );
    wattrset( defwin, A_NORMAL );
    while ( hrcv.data[ i ] != '\x07' ) {
        waddch( defwin, hrcv.data[ i ] );
        i++;
    }
    i++;
    waddch( defwin, '\n' );
    wrefresh( defwin );
    wrefresh( inputwin );

}

void show_me( void )
{
    if ( hrcv.dest != LC_BROADCAST ) {
        wattrset( defwin, COLOR_PAIR( 7 ) );
        wprintw( defwin, "msg" );
        wattrset( defwin, COLOR_PAIR( 4 ) );
        wprintw( defwin, "(" );
        wattrset( defwin, COLOR_PAIR( 5 ) );
        wprintw( defwin, "%s", hrcv.nick );
        wattrset( defwin, COLOR_PAIR( 4 ) );
        wprintw( defwin, ")   " );
        wattrset( defwin, COLOR_PAIR( 5 ) );
    }

    wattrset( defwin, COLOR_PAIR( 6 ) | A_BOLD );
    wprintw( defwin, "* %s ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 5 ) | A_NORMAL );
    decr();
    sline();
    if ( hrcv.dest == LC_BROADCAST ) {
        flog( "* " );
        flog( hrcv.nick );
        flog( " " );
        flog( hrcv.data );
        flog( "\n" );
    }
}

void show_away( void )
{
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "is away: " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    decr();
    sline();
    wattrset( defwin, COLOR_PAIR( 5 ) );
}

void show_pop( void )
{
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "Popup from " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s: ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 8 ) | A_BOLD );
    decr();
    sline();
    beep();
    wattrset( defwin, COLOR_PAIR( 5 ) | A_BOLD );
}

void show_msg( void )
{
    wattrset( defwin, COLOR_PAIR( 7 ) );
    wprintw( defwin, "msg" );
    wattrset( defwin, COLOR_PAIR( 4 ) );
    wprintw( defwin, "(" );
    wattrset( defwin, COLOR_PAIR( 5 ) );
    wprintw( defwin, "%s", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 4 ) );
    wprintw( defwin, ")   " );
    wattrset( defwin, COLOR_PAIR( 5 ) );
    decr();
    sline();
}

void show_join( void )
{
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "from " );
    decr();
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    waddstr( defwin, hrcv.data );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, " joined at " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s", atime( 0 ) );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, ".\n" );
    wattrset( defwin, COLOR_PAIR( 5 ) );
    wrefresh( defwin );
    wrefresh( inputwin );

    flog( hrcv.nick );
    flog( " from " );
    flog( hrcv.data );
    flog( " joined at " );
    flog( atime( 0 ) );
    flog( "\n" );
}

void change_topic( void )
{
    werase( headwin );
    decr();
    if ( !strcmp( hrcv.data, "<>" ) ) {
        wattrset( headwin, A_BOLD );
        wprintw( headwin, "LANChat v%s by Melun", VER );
    }
    else {
        wattrset( headwin, A_BOLD );
        waddstr( headwin, "LANChat: " );
        wattrset( headwin, A_NORMAL );
        waddstr( headwin, hrcv.data );

    }
    if ( hrcv.type == LC_NEWTOPIC ) {
        wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
        wprintw( defwin, "%s ", hrcv.nick );
        wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
        wprintw( defwin, "changed topic to: " );
        wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
        wprintw( defwin, "%s\n", hrcv.data );
        wattrset( defwin, COLOR_PAIR( 5 ) );
    }
    strcpy( topic, hrcv.data );
    wrefresh( headwin );
    wrefresh( defwin );
    wrefresh( inputwin );
}

void show_leave( void )
{
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "left at " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s", atime( 0 ) );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, ".\n" );
    wattrset( defwin, COLOR_PAIR( 5 ) );

    wrefresh( defwin );
    wrefresh( inputwin );
    if ( hrcv.sender != hsnd.sender ) {
        flog( hrcv.nick );
        flog( " left at " );
        flog( atime( 0 ) );
        flog( "\n" );
    }
}

void show_stats( void )  //Eh, statistics should be better...
{
    wprintw( defwin, "LANChat Session Statistics:\n" );
    if ( !cmp( topic, "<>" ) ) wprintw( defwin, "topic: there is no topic\n" );
    else {
        wprintw( defwin, "topic: %s\n", topic );
        wprintw( defwin, "since: %s\n", topictime );
    }

    wprintw( defwin, "Bytes received: %d\n", bytes_rcv );
    wprintw( defwin, "%d packets received\n", total_msg );

    wrefresh( defwin );
    wrefresh( inputwin );
}

void show_help( void )
{

    // Who needs this colors anyway... all help'll be gray:)
    wprintw( defwin, "--------==LANChat Commands Summary==-------\n" );
    wprintw( defwin, "/away <reason> - marks you as \"away\"\n" );
    wprintw( defwin, "/whois nickname - shows information about nick specified\n" );
    wprintw( defwin, "/topic <newtopic> - changes the topic\n" );
    wprintw( defwin, "/sa - show users away reasons\n" );
    wprintw( defwin, "/status - show some usage statistics\n" );
    wprintw( defwin, "/msg \"nickname\" <body> - sends a private message\n" );
    wprintw( defwin, "/pop \"nickname\" <body> - sends a pop-message\n" );
    wprintw( defwin, "/nick <new-nick> - changes your nickname\n" );
    wprintw( defwin, "/me <body> - send a description of what you're doing\n" );
    wprintw( defwin, "/clear - clears screen and sends mother-attack message\n" );
    wprintw( defwin, "/credits - show some credits\n" );
    wprintw( defwin, "/help - what this can be...\n" );
    wprintw( defwin, "/quit - close LANChat session\n" );
    wprintw( defwin, "For more information about each command refer to README file\n" );


    wrefresh( defwin );
    wrefresh( inputwin );
}

void show_credits( void )
{
    wprintw( defwin, "LANChat Credits:\n" );
    wprintw( defwin, "Linux LANChat by melun <melun@friko2.onet.pl>.\n" );
    wprintw( defwin, "Thanks to GORO for network and process code support.\n" );
    wprintw( defwin, "Greets to ABGC network, AJC network, Mi-V, BLADE, [:-{\n" );
    
    wprintw( defwin, "Thanks to all beta-testers and bug notifiers.\n" );
    
    wprintw( defwin, "Send your comments to lanchat@topnet.pl\n" );
    
    wprintw( defwin, "Visit http://www.lanchat.topnet.pl\n" );
    
    wprintw( defwin, "Enjoy !\n" );
    
    wrefresh( defwin );
    wrefresh( inputwin );
}

void show_resurrected( void )
{
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "resurrected at " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s", atime( 0 ) );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, ".\n" );
    wattrset( defwin, COLOR_PAIR( 5 ) );
    wrefresh( defwin );
    wrefresh( inputwin );

}

void show_unknown( void )
{
    decr();
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "Unknown command: " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s\n", hrcv.data );
    wattrset( defwin, COLOR_PAIR( 5 ) );

    wrefresh( defwin );
    wrefresh( inputwin );
}

void show_went_away( void )
{
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s ", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "went away at " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s", atime( 0 ) );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, ": " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    decr();
    sline();
    wattrset( defwin, COLOR_PAIR( 5 ) );

    if ( hrcv.sender == hsnd.sender ) {
        sprintf( away, "%s (%s)", hrcv.data, atime( 0 ) );
    }
    flog( hrcv.nick );
    flog( " went away at " );
    flog( atime( 0 ) );
    flog( ": " );
    flog( hrcv.data );
    flog( "\n" );
}

void show_back_away( void )
{
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s", hrcv.nick );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, " came back at " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "%s", atime( 0 ) );
    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
    wprintw( defwin, "!\n" );
    wattrset( defwin, COLOR_PAIR( 5 ) );
    wrefresh( defwin );
    wrefresh( inputwin );
    flog( hrcv.nick );
    flog( " came back at " );
    flog( atime( 0 ) );
    flog( "!\n" );
}

int prepare_message( void )
{
    int i, nl = -1, nk = 0, np = 0;
    char tnick[ 20 ];

    decrypt( hrcv.xVal, hrcv.data, hrcv.sender, hrcv.dest );

    if ( hrcv.data[ 0 ] == '"' ) {
        for ( i = 1; i < 20; i++ ) if ( hrcv.data[ i ] == '"' ) {
                if ( np == 0 ) nk = i;
                np = 1;
            }
        if ( nk != 0 ) {
            nk--;
            strncpy( tnick, hrcv.data + 1, nk );
            tnick[ nk ] = '\0';
            for ( i = 0; i < 255; i++ ) 
                {
                    if ( !cmp( users[ i ].nick, tnick ) ) nl = i;
                }
                if ( nl == -1 ) {
                        wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                        wprintw( defwin, "error: \"" );
                        wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                        wprintw( defwin, "%s", tnick );
                        wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                        wprintw( defwin, "\" not found.\n" );
                        wattrset( defwin, COLOR_PAIR( 5 ) );
                        wrefresh( defwin );
                        wrefresh( inputwin );
                    }
                    else {
                        hsnd.dest = nl;
                        strcpy( hsnd.data, hrcv.data );
                        strncpy( hsnd.data, hsnd.data + strlen( users[ nl ].nick ) + 3, strlen( hsnd.data ) - strlen( users[ nl ].nick ) + 3 );
                    }
        }
        else {
            wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
            waddstr( defwin, "Syntax error: where is the second \" ?\n" );
            wattrset( defwin, COLOR_PAIR( 5 ) );
            wrefresh( defwin );
            wrefresh( inputwin );
        }
    }
    else {
        wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
        waddstr( defwin, "Usage: /command \"nick name\" message\n" );
        waddstr( defwin, "You have to put nick name in quotation marks\n" );
        wattrset( defwin, COLOR_PAIR( 5 ) );
        wrefresh( defwin );
        wrefresh( inputwin );
    }

    if ( nl == -1 ) return - 1;
    else return 0;

}



int main( void )


{

    int ssock, rsock;
    int buf_size;
    struct sockaddr_in toaddr, outaddr, oth;
    pid_t cp, cp2;
    int i;
    int recv, send;
    bool finish, option;
    int away_mode = 0;
    unsigned char addr;

    register struct hostent *hostptr;
    struct in_addr *ptr;

    hsnd.cCrypt = CRYPT_DEFAULT;

    hsnd.cHead[ 0 ] = 'L';
    hsnd.cHead[ 1 ] = 'C';
    hsnd.cHead[ 2 ] = '4';
    hsnd.cHead[ 3 ] = '0';

    hsnd.nR = COLOR_R;
    hsnd.nG = COLOR_G;
    hsnd.nB = COLOR_B;

    // INITIALIZATION STUFF
    ///////////////////////


    umask( 0 );

    printf( "Initializing LANChat...\n" );

    gethostname( host, 30 );
    hostptr = gethostbyname( host );
    ptr = ( struct in_addr* ) * hostptr->h_addr_list;

    strcpy( host, hostptr->h_name );
    strcpy( myip, inet_ntoa( *ptr ) );

    addr = *( hostptr->h_addr + 3 );

    hsnd.sender = addr;

    ssock = socket( AF_INET, SOCK_DGRAM, IPPROTO_UDP );
    if ( ssock == -1 ) {
        printf( "\n\r\x1b[1;31mERROR:\x1b[m Can't initialize socket...\n\n\r" );
        exit( 1 );
    }
    else printf( "Send Socket: OK\n" );

    buf_size = 1;
    setsockopt( ssock, SOL_SOCKET, SO_BROADCAST, ( char * ) & buf_size, sizeof( buf_size ) );
    buf_size = BUF;
    setsockopt( ssock, SOL_SOCKET, SO_SNDBUF, ( char * ) & buf_size, sizeof( buf_size ) );

    toaddr.sin_family = AF_INET;
    toaddr.sin_port = htons( INPORT );
    toaddr.sin_addr.s_addr = INADDR_BROADCAST;

    rsock = socket( PF_INET, SOCK_DGRAM, 0 );
    if ( rsock == -1 ) {
        printf( "\n\r\x1b[1;31mERROR:\x1b[m Can't initialize socket...\n\n\r" );
        exit( 1 );
    }
    else printf( "Receive Socket: OK\n" );

    buf_size = 1;
    
    setsockopt( rsock, SOL_SOCKET, SO_BROADCAST, &buf_size, sizeof( buf_size ) );
    
    buf_size = BUF;
    
    setsockopt( rsock, SOL_SOCKET, SO_RCVBUF, &buf_size, sizeof( buf_size ) );
    

    outaddr.sin_family = AF_INET;
    
    outaddr.sin_port = htons( INPORT );
    outaddr.sin_addr.s_addr = htonl( INADDR_ANY );

    if ( bind( rsock, ( struct sockaddr * ) ( &outaddr ), sizeof( struct sockaddr ) ) < 0 ) {
                printf( "\n\r\x1b[1;31mERROR:\x1b[m Can't bind receive socket. Perheps you're \n\r" );
                printf( "trying to run lanchat twice on the same machine.\n\n" );
                exit( 1 );
            } 

    if ( ( cp2 = fork() ) == -1 ) {
        endwin();
        perror( "fork" );
        exit( 1 );
    }

    if ( cp2 == 0 ) {
        while ( 1 ) {
            hsnd.dest = hsnd.sender;
            hsnd.type = LC_LINUX_REQUEST;
            snd();
            sleep( 5 );
        }
    }

    else


        //let's rock with interfejz
        initscr();
    start_color();
    headwin = newwin( 1, 80, 0, 0 );
    defwin = newwin( 21, 60, 1, 0 );
    userwin = newwin( 21, 16, 1, 63 );
    inputwin = newwin( 1, 80, 24, 0 );
    split1win = newwin( 2, 80, 22, 0 );
    split2win = newwin( 21, 1, 1, 61 );
    werase( headwin );
    werase( defwin );
    werase( userwin );
    werase( inputwin );
    werase( split1win );
    werase( split2win );

    init_pair( 1, COLOR_WHITE, COLOR_BLUE );
    init_pair( 5, COLOR_WHITE, COLOR_BLACK );
    init_pair( 4, COLOR_CYAN, COLOR_BLACK );
    init_pair( 2, COLOR_BLUE, COLOR_BLACK );
    init_pair( 3, COLOR_MAGENTA, COLOR_BLACK );
    init_pair( 6, COLOR_GREEN, COLOR_BLACK );
    init_pair( 7, COLOR_RED, COLOR_BLACK );
    init_pair( 8, COLOR_YELLOW, COLOR_BLACK );



    scrollok( defwin, TRUE );
    scrollok( inputwin, TRUE );
    keypad( inputwin, TRUE );
    nonl();

    wattron( headwin, COLOR_PAIR( 1 ) );
    wbkgdset( headwin, COLOR_PAIR( 1 ) );

    wattron( split1win, COLOR_PAIR( 1 ) | A_BOLD );
    wbkgdset( split1win, COLOR_PAIR( 1 ) );

    wattron( split2win, COLOR_PAIR( 2 ) );

    for ( i = 0; i < 24; i++ ) mvwaddch( split2win, i, 0, ACS_VLINE );

    for ( i = 0; i < 160; i++ ) waddch( split1win, ' ' );

    updateall();

    finish = FALSE;
    option = FALSE;

    signal( SIGINT, use_exit );

    strcpy( since, atime( 0 ) );
    strcpy( topic, "<>" );


    strcpy( logname, getenv( "LOGNAME" ) );
    strcpy( hsnd.nick, logname );
    pop_mode = 0;

    wattrset( defwin, COLOR_PAIR( 4 ) );
    wprintw( defwin, "Welcome to " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "Linux LANChat v%s", VER );
    wattrset( defwin, COLOR_PAIR( 4 ) );
    wprintw( defwin, " Melun melun@friko2.onet.pl\n" );
    wprintw( defwin, "Distributed without any warranty under GPL version 2 terms\n" );
    wprintw( defwin, "and conditions.\n" );
    wprintw( defwin, "This program is a Linux adaptation of the original LANChat\n" );
    wprintw( defwin, "
for windows. Type " );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "/help " );
    wattrset( defwin, COLOR_PAIR( 4 ) );
    wprintw( defwin, "for commands summary.\n" );
    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
    wprintw( defwin, "http://lanchat.topnet.pl\n\n" );
    wattrset( defwin, COLOR_PAIR( 5 ) );

    if ( ( cp = fork() ) == -1 ) {
        endwin();
        perror( "fork" );
        exit( 1 );
    }



    if ( cp == 0 ) {
        while ( 1 ) {
            buf_size = sizeof( struct sockaddr );
            recv = recvfrom( rsock, &hrcv, BUF, 0, ( struct sockaddr * ) & oth, ( int * ) & buf_size );

            if ( recv != -1 ) {
                bytes_rcv += recv;
                total_msg++;
            }
            //simple packet checking

            if ( ( hrcv.cHead[ 0 ] != 'L' ) || ( hrcv.cHead[ 1 ] != 'C' )
                    || ( hrcv.cHead[ 2 ] != '4' ) || ( hrcv.cHead[ 3 ] != '0' ) ) {
                wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                wprintw( defwin, "DANGER: Strange packet was received on lanchat port.\n" );
                wattrset( defwin, COLOR_PAIR( 5 ) );
                wrefresh( defwin );
                wrefresh( inputwin );
            }
            else

                if ( users[ hrcv.sender ].lag == 3 ) show_resurrected();
            if ( hrcv.dest == hsnd.sender || hrcv.dest == LC_BROADCAST )
                switch ( hrcv.type ) {

                    //***internal messages***//
                case LC_LINUX_MSG:   //send msg


                    if ( !prepare_message() ) {
                        wattrset( defwin, COLOR_PAIR( 7 ) );
                        wprintw( defwin, "msg" );
                        wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                        wprintw( defwin, " --> " );
                        wattrset( defwin, COLOR_PAIR( 4 ) | A_NORMAL );
                        wprintw( defwin, "(" );
                        wattrset( defwin, COLOR_PAIR( 5 ) );
                        wprintw( defwin, "%s", users[ hsnd.dest ].nick );
                        wattrset( defwin, COLOR_PAIR( 4 ) );
                        wprintw( defwin, ")   " );
                        wattrset( defwin, COLOR_PAIR( 5 ) );
                        hsnd.data[ strlen( hsnd.data ) - 2 ] = '\0';
                        wprintw( defwin, "%s\n", hsnd.data );
                        wrefresh( defwin );
                        wrefresh( inputwin );
                        hsnd.type = LC_NORMAL;
                        strcat( hsnd.data, "\x0d\x0a\0" );
                        crypt( hsnd.data, hsnd.sender, hsnd.dest );
                        snd();
                    }
                    break;
                case LC_LINUX_STATUS:
                    show_stats();
                    break;
                case LC_LINUX_POP:   //send pop

                    if ( !prepare_message() ) {
                        hsnd.type = LC_POPUP;
                        crypt( hsnd.data, hsnd.sender, hsnd.dest );
                        snd();
                    }
                    break;
                case LC_LINUX_HELP:
                    show_help();
                    break;
                case LC_LINUX_CREDITS:
                    show_credits();
                    break;
                case LC_LINUX_UNKCMD:
                    show_unknown();
                    break;
                case LC_LINUX_WHOIS:
                    decr();
                    if ( auser( hrcv.data ) != -1 ) {
                        hsnd.type = LC_REQ_STATUS_EX;
                        hsnd.dest = auser( hrcv.data );
                        snd();
                    }
                    else {
                        wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                        wprintw( defwin, "No such user: " );
                        wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                        wprintw( defwin, "%s\n", hrcv.data );
                        wattrset( defwin, COLOR_PAIR( 5 ) );
                        wrefresh( defwin );
                        wrefresh( inputwin );
                    }
                    break;
                case LC_LINUX_NICKLN:
                    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                    wprintw( defwin, "Nick length have to be >2 and <20.\n" );
                    wattrset( defwin, COLOR_PAIR( 5 ) );
                    wrefresh( defwin );
                    wrefresh( inputwin );
                    break;
                case LC_LINUX_REQUEST:
                    hsnd.dest = LC_BROADCAST;
                    if ( users[ hsnd.sender ].away == 0 ) hsnd.type = LC_ALIVE;
                    else hsnd.type = LC_AWAY_ALIVE;
                    snd();

                    for ( i = 0; i < 255; i++ ) 
                        if ( strlen( users[ i ].nick ) > 0 && i != hsnd.sender ) {
                            users[ i ].lag++;
                            if ( users[ i ].lag == 3 ) {

                                wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                                wprintw( defwin, "%s ", users[ i ].nick );
                                wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                                wprintw( defwin, "timed out at " );
                                wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                                wprintw( defwin, "%s", atime( 0 ) );
                                wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                                wprintw( defwin, ".\n" );
                                wattrset( defwin, COLOR_PAIR( 5 ) );

                                users[ i ].nick[ 0 ] = '\0';
                                make_userlist();
                                wrefresh( defwin );
                                wrefresh( inputwin );
                            }
                        }
                    break;

                    //***external messagess***//
                case LC_ADD_TO_ROOM:
                    users[ hrcv.sender ].room = 1;
                    break;
                case LC_REMOVE_FROM_ROOM:
                    users[ hrcv.sender ].room = 0;
                    break;
                case LC_TOPIC:
                case LC_NEWTOPIC:
                    change_topic();
                    break;
                case LC_TOPIC_TIME:
                    decrypt( hrcv.xVal, hrcv.data, hrcv.sender, hrcv.dest );
                    hrcv.data[ strlen( hrcv.data ) - 2 ] = '\0';
                    strncpy( topictime, hrcv.data, 8 );
                    break;
                case LC_POPOK:
                case LC_CANTPOP:
                    if ( hrcv.type == LC_POPOK )
                        wprintw( defwin, "POP-UP has been received.\n", hrcv.nick );
                    else
                        wprintw( defwin, "%s has popup's disabled.\n", hrcv.nick );
                    wattrset( defwin, COLOR_PAIR( 5 ) );
                    wrefresh( defwin );
                    wrefresh( inputwin );
                    break;
                case LC_POPUP:
                    if ( hrcv.sender != hsnd.sender ) {
                        if ( pop_mode == 0 ) {
                            hsnd.type = LC_POPOK;
                            show_pop();
                        }
                        else hsnd.type = LC_CANTPOP;
                        hsnd.dest = hrcv.sender;
                        snd();
                    }
                    break;
                case LC_MOTHER:
                    wattrset( defwin, COLOR_PAIR( 5 ) | A_BOLD );
                    wprintw( defwin, "%s has a mother attack!\n", hrcv.nick );
                    wattrset( defwin, COLOR_PAIR( 5 ) | A_NORMAL );
                    if ( hrcv.sender == hsnd.sender ) {
                        werase( defwin );
                        wrefresh( defwin );
                        wrefresh( inputwin );
                    }
                    break;
                case LC_REQ_STATUS_EX:
                    hsnd.dest = hrcv.sender;
                    hsnd.type = LC_STATUS_EX;

                    sprintf( hsnd.data, \
                             "%s\x07%s@%s\x07%s\x07LANChat %s\x07%s\x07%d\x07%s\x07", \
                             hsnd.nick, logname, host, myip, VER, OS, \
                             users[ hsnd.sender ].away, since );

                    strcat( hsnd.data, "\x0d\x0a\0" );
                    crypt( hsnd.data, hsnd.sender, hsnd.dest );
                    snd();
                    break;
                case LC_STATUS_EX:
                    if ( hrcv.dest == hsnd.sender ) show_status();
                    break;
                case LC_NORMAL:
                    if ( hrcv.dest == LC_BROADCAST )
                        show_normal();
                    else
                        show_msg();
                    break;
                case LC_ME:
                    show_me();
                    break;
                case LC_JOIN:
                    show_join();
                    strcpy( users[ hrcv.sender ].nick, hrcv.nick );
                    users[ hrcv.sender ].away = 0;
                    make_userlist();
                    hsnd.dest = hrcv.sender;
                    if ( users[ hsnd.sender ].away == 0 ) hsnd.type = LC_ALIVE;
                    else hsnd.type = LC_AWAY_ALIVE;
                    snd();
                    hsnd.type = LC_TOPIC;
                    strcpy( hsnd.data, topic );
                    strcat( hsnd.data, "\x0d\x0a\0" );
                    crypt( hsnd.data, hsnd.sender, hsnd.dest );
                    snd();
                    hsnd.type = LC_TOPIC_TIME;
                    strcpy( hsnd.data, topictime );
                    strcat( hsnd.data, "\x0d\x0a\0" );
                    crypt( hsnd.data, hsnd.sender, hsnd.dest );
                    snd();
                    break;
                case LC_LEAVE:
                    users[ hrcv.sender ].nick[ 0 ] = '\0';
                    show_leave();
                    make_userlist();
                    if ( hrcv.sender == hsnd.sender ) exit( 0 );
                    break;
                case LC_AWAY:
                    show_away();
                    break;
                case LC_ALIVE:
                    strcpy( users[ hrcv.sender ].nick, hrcv.nick );
                    users[ hrcv.sender ].away = 0;
                    make_userlist();
                    users[ hrcv.sender ].lag = 0;
                    break;
                case LC_REQ_AWAY:
                    if ( users[ hsnd.sender ].away == 1 ) {
                        hsnd.dest = hrcv.sender;
                        hsnd.type = LC_AWAY;
                        strcpy( hsnd.data, away );
                        strcat( hsnd.data, "\x0d\x0a\0" );
                        crypt( hsnd.data, hsnd.sender, hsnd.dest );
                        snd();
                    }
                    break;
                case LC_REQ_ALIVE:
                    hsnd.dest = hrcv.sender;
                    if ( users[ hsnd.sender ].away == 0 ) hsnd.type = LC_ALIVE;
                    else hsnd.type = LC_AWAY_ALIVE;
                    snd();
                    break;
                case LC_START_AWAY:
                    users[ hrcv.sender ].away = 1;
                    show_went_away();
                    make_userlist();
                    break;
                case LC_END_AWAY:
                    users[ hrcv.sender ].away = 0;
                    show_back_away();
                    make_userlist();
                    break;
                case LC_AWAY_ALIVE:
                    strcpy( users[ hrcv.sender ].nick, hrcv.nick );
                    users[ hrcv.sender ].away = 1;
                    make_userlist();
                    users[ hrcv.sender ].lag = 0;
                    break;
                case LC_NEWNICK:


                    if ( hrcv.sender == hsnd.sender ) strcpy( hsnd.nick, hrcv.nick );

                    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                    wprintw( defwin, "Now " );
                    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                    wprintw( defwin, "%s", users[ hrcv.sender ].nick );
                    wattrset( defwin, COLOR_PAIR( 2 ) | A_BOLD );
                    wprintw( defwin, " is known as " );
                    wattrset( defwin, COLOR_PAIR( 4 ) | A_BOLD );
                    wprintw( defwin, "%s\n", hrcv.nick );
                    wattrset( defwin, COLOR_PAIR( 5 ) );

                    wrefresh( defwin );
                    wrefresh( inputwin );

                    strcpy( users[ hrcv.sender ].nick, hrcv.nick );
                    make_userlist();
                    break;
                }
        }
    }
    else {
        flog( "LANChat Session opened at: " );
        flog( atime( 0 ) );
        flog( "\n" );
        hsnd.type = LC_JOIN;
        hsnd.dest = LC_BROADCAST;
        sprintf( hsnd.data, "(%s, IP=%s)", host, myip );
        strcat( hsnd.data, "\x0d\x0a\0" );
        crypt( hsnd.data, hsnd.sender, hsnd.dest );
        snd();

        while ( !finish ) {
            mvwgetstr( inputwin, 0, 0, hsnd.data );
            option = FALSE;
            hsnd.type = 0;
            hsnd.dest = hsnd.sender;

            if ( away_mode == 1 ) {
                hsnd.type = LC_END_AWAY;
                hsnd.dest = LC_BROADCAST;
                snd();
                away_mode = 0;
            }

            if ( !cmp( hsnd.data, "/quit" ) ) {
                finish = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_LEAVE;
                hsnd.data[ 0 ] = '\0';
            }
            if ( !cmp( hsnd.data, "/whois " ) ) {
                option = TRUE;
                hsnd.dest = hsnd.sender;
                hsnd.type = LC_LINUX_WHOIS;
                strncpy( hsnd.data, hsnd.data + 7, strlen( hsnd.data ) - 7 );
                hsnd.data[ strlen( hsnd.data ) - 7 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );

            }
            if ( !cmp( hsnd.data, "/away " ) ) {
                option = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_START_AWAY;
                strncpy( hsnd.data, hsnd.data + 6, strlen( hsnd.data ) - 6 );
                hsnd.data[ strlen( hsnd.data ) - 6 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );
                away_mode = 1;
            }
            if ( !cmp( hsnd.data, "/topic " ) ) {
                option = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_NEWTOPIC;
                strncpy( hsnd.data, hsnd.data + 7, strlen( hsnd.data ) - 7 );
                hsnd.data[ strlen( hsnd.data ) - 7 ] = '\0';
                strcat( hsnd.data, " (" );
                strcat( hsnd.data, hsnd.nick );
                strcat( hsnd.data, ")" );
                strcat( hsnd.data, "\x0d\x0a\0" );
                crypt( hsnd.data, hsnd.sender, hsnd.dest );
                snd();
                hsnd.type = LC_TOPIC_TIME;
                strcpy( hsnd.data, atime( 0 ) );
                strcat( hsnd.data, "\x0d\x0a\0" );
            }
            if ( !cmp( hsnd.data, "/sa" ) ) {
                option = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_REQ_AWAY;
                hsnd.data[ 0 ] = '\0';
            }
            if ( !cmp( hsnd.data, "/status" ) ) {
                option = TRUE;
                hsnd.dest = hsnd.sender;
                hsnd.type = LC_LINUX_STATUS;
                hsnd.data[ 0 ] = '\0';
            }
            if ( !cmp( hsnd.data, "/help" ) ) {
                option = TRUE;
                hsnd.dest = hsnd.sender;
                hsnd.type = LC_LINUX_HELP;
                hsnd.data[ 0 ] = '\0';
            }
            if ( !cmp( hsnd.data, "/credits" ) ) {
                option = TRUE;
                hsnd.dest = hsnd.sender;
                hsnd.type = LC_LINUX_CREDITS;
                hsnd.data[ 0 ] = '\0';
            }
            if ( !cmp( hsnd.data, "/msg " ) ) {
                option = TRUE;
                hsnd.dest = hsnd.sender;
                hsnd.type = LC_LINUX_MSG;
                strncpy( hsnd.data, hsnd.data + 5, strlen( hsnd.data ) - 5 );
                hsnd.data[ strlen( hsnd.data ) - 5 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );
            }
            if ( !cmp( hsnd.data, "/pop " ) ) {
                option = TRUE;
                hsnd.dest = hsnd.sender;
                hsnd.type = LC_LINUX_POP;
                strncpy( hsnd.data, hsnd.data + 5, strlen( hsnd.data ) - 5 );
                hsnd.data[ strlen( hsnd.data ) - 5 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );
            }
            if ( !cmp( hsnd.data, "/clear" ) ) {
                option = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_MOTHER;
                hsnd.data[ 0 ] = '\0';
            }
            if ( !cmp( hsnd.data, "/me " ) ) {
                option = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_ME;
                strncpy( hsnd.data, hsnd.data + 4, strlen( hsnd.data ) - 4 );
                hsnd.data[ strlen( hsnd.data ) - 4 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );
            }
            if ( !cmp( hsnd.data, "/nick " ) ) {
                option = TRUE;
                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_NEWNICK;
                strncpy( hsnd.data, hsnd.data + 6, strlen( hsnd.data ) - 6 );
                hsnd.data[ strlen( hsnd.data ) - 6 ] = '\0';
                if ( ( strlen( hsnd.data ) < 3 ) || ( strlen( hsnd.data ) > 19 ) )
                    hsnd.type = LC_LINUX_NICKLN;
                else {
                    strncpy( users[ hsnd.sender ].nick, hsnd.data, 20 );
                    users[ hsnd.sender ].nick[ 19 ] = '\0';
                    strcpy( hsnd.nick, users[ hsnd.sender ].nick );
                }
            }

            if ( ( strlen( hsnd.data ) > 0 ) && ( !finish ) && ( !option ) ) {
                strcat( hsnd.data, "\x0d\x0a\0" );
                hsnd.type = LC_NORMAL;
                hsnd.dest = LC_BROADCAST;
            }

            if ( ( !option ) && !cmp( hsnd.data, "/" ) ) {

                hsnd.type = LC_LINUX_UNKCMD;
                hsnd.dest = hsnd.sender;
            }

            crypt( hsnd.data, hsnd.sender, hsnd.dest );
            snd();
            wdeleteln( inputwin );
            wrefresh( inputwin );
        }
    }

    flog( "LANChat Session closed at: " );
    flog( atime( 0 ) );
    flog( "\n" );
    flog( "===================================\n" );
    endwin();
    kill( cp2, SIGTERM );
    return( 0 );
}

